#
## Author: Ian Mitchell / Middlesex University
# NO WARRANTY
# 4 Neuron pyNN Tutorial
from pyNN.spiNNaker import *
import pylab
POPULATION_SIZE = 100
SIMULATION_TIME = 500
WEIGHT		= 2.0
DELAY		= 1.0
#plot spikes for population, pop, in file, filename
def plotSpikes(spikes):
	if spikes is not None:
		print spikes
    		pylab.figure()
    		pylab.plot([i[1] for i in spikes], [i[0] for i in spikes], ".")
    		pylab.xlabel('Time/ms')
    		pylab.ylabel('spikes')
    		pylab.title('spikes for Population')
    		pylab.show()
	else:
    		print "No spikes received"

setup(timestep=DELAY, min_delay=DELAY, max_delay=DELAY+10)
cell_params = {'tau_refrac' : 5.0,'v_rest' : -65.0,'v_thresh' : -51.0,'tau_syn_E':2.0,
		'tau_syn_I': 5.0,'v_reset': -70.0,'i_offset': 0.0,'cm': 0.1}
connList=list()
for i in range(0,POPULATION_SIZE,1):
	for j in range(0,POPULATION_SIZE,1):
		singleConn=(i,j,WEIGHT,DELAY)
		connList.append(singleConn)
spikeTimes = [[i for i in range(0,10,1)]]	
neuron_1 = Population(1, SpikeSourceArray,{'spike_times': spikeTimes})
neuron_2 = Population(POPULATION_SIZE, IF_curr_exp, cell_params)
injectionConnection = [(0, 0, WEIGHT, DELAY)]
Projection(neuron_1,neuron_2,FromListConnector(injectionConnection))
Projection(neuron_2,neuron_2,FromListConnector(connList))
neuron_2.record()
run(SIMULATION_TIME)
spikes1 = neuron_2.getSpikes(compatible_output=True)
plotSpikes( spikes1 )
end()
